//+------------------------------------------------------------------+
//|                                               Sto CCI RSI EA.mq4 |
//+------------------------------------------------------------------+
#import   "stdlib.ex4"
  string  ErrorDescription(int error_code);
#import
#include  <stderror.mqh>
#define   NAME         "Sto_CCI_RSI EA"
#define   VERSION      "v7.2"
//#property indicator_chart_window

extern string EA_Name = "Sto_CCI_RSI_M1_V7.2";
extern double lotSize=0.01;
extern int    StopLoss=300;
extern int    TakeProfit=100;

extern int    StochTF = 5;

extern int    RsiPer          =  13;
extern int    StochPer        =   8;
extern int    CCIPer          =   8;
extern double Hot             = 0.4;
extern int    Smoothing       =   4;
extern bool   CloseAtOpositeCross = true;

extern int       FirstEven=300;
extern bool      Alerts = true;

extern int       LabelXpos=10;
extern int       LabelYpos=15;
extern string    Capture="Screeshots (Stocked in ..\experts\files)";
extern bool      TakeScreenShot = true;
extern int       size_x = 1280;
extern int       size_y = 720;
extern int       magicNumber = 7112011;

int ticket;
int a = 0;
int i, f;
double savedVolume;
double TPPoints, SLPoints;
 string symbolpair, time;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  
  
  bool newBarFormed() {
  bool ret=Volume[0] < savedVolume;
  savedVolume = Volume[0];
  return(ret);
  

}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  int start()
  {
if (OrdersTotal()>0) 
OrdersList();  


int trendNow1 = iCustom(NULL,0,"Sto_CCI_RSI 2","",RsiPer,StochPer,CCIPer,Hot,Smoothing,4,0);
int trendPre1 = iCustom(NULL,0,"Sto_CCI_RSI 2","",RsiPer,StochPer,CCIPer,Hot,Smoothing,4,1);
int trendNow2 = iCustom(NULL,0,"Sto_CCI_RSI 2",StochTF,RsiPer,StochPer,CCIPer,Hot,Smoothing,4,0);




//------------------------------------------

symbolpair = Symbol();
time = TimeToStr(TimeCurrent());

if (newBarFormed()) 
{

 
 //------------ verif de positions
  int scnt = 0,f = 0, bcnt = 0, cnt = OrdersTotal();
    for (i = 0; i < cnt; i++)
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        if (OrderMagicNumber() == magicNumber)
          if (OrderType() == OP_BUY && OrderSymbol() == symbolpair)
          {
          
          
          if (CloseAtOpositeCross) 
          {
          if(trendNow2==-1)
          {
          
         while (OrderClose(OrderTicket(),OrderLots(),Bid,3) == false && f < 10)
         {
          f++;
         RefreshRates();  
         OrderClose(OrderTicket(),OrderLots(),Bid,3);
           Sleep(1000);   
         }
          a=3;
            Alert(Symbol()," - Sto_CCI_RSI CLOSED - ",Period()," @ ",Bid," ",time);
          }
          }
          
          bcnt++;
          }
          else 
          if (OrderType() == OP_SELL && OrderSymbol() == symbolpair)
          {
          
          if (CloseAtOpositeCross) 
          {
          if( trendNow2==1)
         {
         while (OrderClose(OrderTicket(),OrderLots(),Ask,3) == false && f < 10)
         {
         f++;   
         RefreshRates();  
         OrderClose(OrderTicket(),OrderLots(),Ask,3);
           Sleep(1000); 
         }
          a=3;
            Alert(Symbol()," - Sto_CCI_RSI CLOSED - ",Period()," @ ",Ask," ",time);
          }
          }
          
          scnt++;
          }
  // -------------- fin verif
}

// {
   //------------------------------------------
if (trendNow1!=trendPre1)
{  
   if( trendNow1==1 && trendNow2==1 && a != 1)
  {
  
   
  if (Alerts == true)
  Alert(Symbol()," - Sto_CCI_RSI UP - BUY - ",Period()," @ ",Bid," ",time);
  
  if (bcnt == 0)
 {
 
 //----------- passage d'ordre avec verif harcelement
 ticket=OrderSend(Symbol(), OP_BUY, lotSize, Ask, 3, Ask-StopLoss*Point, Ask+TakeProfit*Point, NAME + " " + EA_Name, magicNumber,0,Green);
 
 while (ticket == -1) // tant que lordre nest pas pass
{
   RefreshRates();   //on rafraichit les valeurs du cours de la paire
   ticket = OrderSend(Symbol(), OP_BUY, lotSize, Ask, 3, Ask-StopLoss*Point, Ask+TakeProfit*Point, NAME + " " + EA_Name, magicNumber,0,Green);
   Sleep(1000);      // on attend une seconde
}
 //------------ fin passage d'ordre
 
 //OrderSend(Symbol(), OP_BUY, lotSize, Ask, 3, 0, 0, NAME + " " + VERSION, magicNumber);
 
 if (TakeScreenShot == true)
 if(!WindowScreenShot(StringConcatenate(NAME + "-" + Symbol(),"-",Period(),"-",TimeToStr(TimeCurrent(),TIME_DATE),"-",Hour(),"H",Minute(),".gif"),size_x,size_y)) 
 Print(GetLastError());  
 }
 a = 1;
 
 
 }
  
 if(trendNow1==-1 && trendNow2==-1&& a != 2)
 {
 
 
 
 if (Alerts == true)
 Alert(Symbol()," - Sto_CCI_RSI DOWN - SELL - ",Period()," @ ",Bid," ",time);
 
 if (scnt == 0)
 {
 
   //----------- passage d'ordre avec verif harcelement
 ticket=OrderSend(Symbol(), OP_SELL, lotSize, Bid, 3, Bid+StopLoss*Point, Bid-TakeProfit*Point, NAME + " " + EA_Name, magicNumber,0,Red);
 
 while (ticket == -1) // tant que lordre nest pas pass
{
   RefreshRates();   //on rafraichit les valeurs du cours de la paire
 ticket=OrderSend(Symbol(), OP_SELL, lotSize, Bid, 3, Bid+StopLoss*Point, Bid-TakeProfit*Point, NAME + " " + EA_Name, magicNumber,0,Red);
 Sleep(1000);      // on attend une seconde
}
 //------------ fin passage d'ordre
 
 
 // OrderSend(Symbol(), OP_SELL, lotSize, Bid, 3, 0, 0, NAME + " " + EA_Name, magicNumber);
 if (TakeScreenShot == true)
 if(!WindowScreenShot(StringConcatenate(NAME + "-" + Symbol(),"-",Period(),"-",TimeToStr(TimeCurrent(),TIME_DATE),"-",Hour(),"H",Minute(),".gif"),size_x,size_y)) 
 Print(GetLastError());  
 }
 a = 2;  
 
 
 
 }
}
  //------------------------------------------

  
// }  
  
 return(0); }
//+------------------------------------------------------------------+
void OrdersList()
{      
    for (int cnt=0;cnt<OrdersTotal();cnt++)
    { 
     OrderSelect(cnt, SELECT_BY_POS);      
        if (OrderSymbol()==Symbol()  && OrderMagicNumber() == magicNumber) 
        {
            if (OrderType()==OP_BUY)
            {
               /*   if (OrderStopLoss()==0) 
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-StopLoss*Point,OrderOpenPrice()+TakeProfit*Point,0,LightGreen);
			      return(0);
			      } */
			     
			      //---- FirstEven
               if (Bid-OrderOpenPrice()>Point*FirstEven&&OrderStopLoss()<OrderOpenPrice()) 
                  {
              
                  {OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,LightGreen);
                  return(0);}
			         }
			      
                 
			   }
            if (OrderType()==OP_SELL)
            {
               /* if (OrderStopLoss()==0) 
               {
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+StopLoss*Point,OrderOpenPrice()-TakeProfit*Point,0,Yellow);
               return(0);
               } */
              
                //---- FirstEven
                if (OrderOpenPrice()-Ask>Point*FirstEven&&OrderStopLoss()>OrderOpenPrice()) 
                  {
                
                  {OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,Yellow);	    
                  }
                  return(0);
			         }
	
			         
	
                  }
            }    
         }   
      } 
      



//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
//----

ObjectDelete("BarTimer3");
ObjectDelete("BarTimer4");

  
//----
  return(0);
}